function GenTheta_dat_s

clc


Probname = {'theta4', 'theta42',  'theta6',  'theta62',   'theta8',   'theta82',  'theta83', 'theta10', 'theta102',...
            'theta103', 'theta104',  'theta12',   'theta123','theta32'};

nprob = length(Probname);

Problist = [1:nprob];

% Problist = [1];

for di = 1:length(Problist)
    
    name = Probname{Problist(di)};

    fid = fopen(strcat(name,'.dat-s'), 'r');
    m = fscanf(fid, '%d', 1);   p = m-1;
    fscanf(fid, '%d', 1);
    n  = fscanf(fid, '%d', 1);
    [b, count] = fscanf(fid, '%f', m);  % read b
    fprintf('b: number of data: %d \n', count);
    [C, count] = fscanf(fid, '%d %d %d %d %f', [5, (n*(n+1))/2]);  % read C
    fprintf('C: number of data: %d \n', count);
    [C, count] = fscanf(fid, '%d %d %d %d %f', [5, n]);  % read <I, X> = 1
    fprintf('I: number of data: %d \n', count);
    
    [E, count] = fscanf(fid, '%d %d %d %d %f', [5, p]);    % It has two rows now.
    fprintf('E: number of data: %d \n', count);

    E = E(3:4,:); E = E';
    fclose(fid);
    
    d = true(p,1);
    T = logical(sparse(E(:,1), E(:,2), d, n, n));

    fprintf('Prob: %s, Trace(T): %f\n', name, full(sum(diag(T))));

    % Be careful, only take the upper triangle matrix of T
    TL = tril(T);
    if sum(sum(TL)) > 0
        T = triu(T);
        [row,col] = find(T);
        p = length(row);     E = zeros(p,2);
        E(:,1) = row; E(:,2) = col;
    end
        

    file = strcat(name,'_Alt.mat');
    save(file, 'n', 'm', 'p','T','E');

end

