%----------------------------------------------------------------------------
% Run this script in Matlab command window
% Compile C-language Mex files
%
% ***************************************************
% Acknowledgement:
%   This script is based on "Installmex.m" from SDPNAL
% ***************************************************
%
% Zaiwen Wen
% 08-12-2009
%----------------------------------------------------------------------------
%
%
%

function Installmex

computer_model = computer;
matlabversion = sscanf(version,'%f');
matlabversion = matlabversion(1);

if strcmp(computer_model,'PCWIN')
    str1 = [matlabroot,'\extern\lib\win32\lcc\libmwlapack.lib  '];
    str2 = [matlabroot,'\extern\lib\win32\lcc\libmwblas.lib  '];
    libstr = [str1,str2];
elseif strcmp(computer_model,'PCWIN64')
    str1 = [matlabroot,'\extern\lib\win64\lcc\libmwlapack.lib  '];
    str2 = [matlabroot,'\extern\lib\win64\lcc\libmwblas.lib  '];
    libstr = [str1,str2];
elseif (matlabversion <= 7.3)
    libstr = '    ';
else
    libstr = '-lmwlapack -lmwblas  ';
end
% mexcmd = 'mex -O  -largeArrayDims  -output ';
mexcmd = 'mex -O  -largeArrayDims   ';

if (matlabversion < 7.3)
    error(' AltSDP works only for MATLAB version 7.3 and above');
end
fsp = filesep;

curdir = pwd;
fprintf(' current directory is:  %s\n',curdir);

% generate mex files in mexfun
clear fname
src = curdir;
fprintf ('\n Now compiling the mexFunctions in:\n');
fprintf (' %s\n',src);

idx = 1;	   fname{idx} = ' mexAltSDP_Theta';
idx= idx+1;     fname{idx} = ' mexAltSDP_ThetaPlus';
idx= idx+1;     fname{idx} = ' mexAltSDP_BIQ';
idx= idx+1;     fname{idx} = ' mexAltSDP_FAP';

common =  '  AltSDP_util.c  AltSDP_util.h ';

for k = 1:length(fname)
    cmd([mexcmd,fname{k}, '.c   ', common, libstr]);
end
% 
% cmd([mexcmd,  'mexeig.c   ',  libstr]);
% cmd([mexcmd,  'MexDSYEVX.c   ',  libstr]);

% create directory "result" to store results
if ~isdir('result')
    fprintf('Create directory ''result'':\n');
    mkdir('result');
end


%%***********************************************
function cmd(s)

fprintf(' %s\n',s);
eval(s);
%%***********************************************
